/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


// $Id: imp_code.C,v 1.4 1995/03/01 01:42:43 steve Exp $
// Implementation-dependent code to be executed
// at the begining and end of main().  By
// implementation-dependent we mean that it
// depeneds on the database being used.

#ifndef	__sys_types_h
#ifndef __TYPES_H
#include <sys/types.h> // For fstat
#endif
#endif

#ifndef	__sys_stat_h
#include <sys/stat.h>
#endif

#include <errno.h>

#ifndef BASICS_H
#include "basics.H"
#endif

#ifndef SAFE_H
#include "safe.H"
#endif


void main_start(int argc, char** argv)
{
  if (argc > 1) {
    struct stat buf;
    int r = stat(argv[1], &buf);
    ABORT(r == -1 && errno != ENOENT, errno_msg());
    ABORT(sizeof(os_unsigned_int32) != sizeof(off_t),"Needs porting");
    ABORT(!r && buf.st_size < 0, "Illegal st_size");
    os_unsigned_int32 size = (os_unsigned_int32) (r ? 0 : buf.st_size);
// Temorary, for benchmarking:
    objectstore::set_cache_size(size + 80000000);

//  Logging within lb is not implemented yet (and may not need to be implemented
//  for some time, if we use the current code) so the following is not
//  needed.
//
//    if (argc > 2) {
//      char *log_file = argv[2];
//      int x = stat(log_file, &buf);
//      ABORT(x == -1 && errno != ENOENT, errno_msg());
//      if (errno == ENOENT) log_stream = new ofstream(log_file, ios::out);
//      else ABORT(1, "Log file already exists");
//    } else cerr << argv[0] << ": logging turned off\n";

  }
  
}


void main_end(int, char**)
{
}

