/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef QL_ADORNMENT_H                                                              
#define QL_ADORNMENT_H

#ifndef BASICS_H
#include "basics.H"
#endif

// Implements the class of adornments for LBQL predicates.

class QL_Adornment
{
public:
  int operator == (const QL_Adornment& a) const;
  QL_Adornment(const char * = "");
  operator char*();
  char *braces() const;
  void add(char);
  int number_free() const, number_bound() const;
  char operator [] (int) const;
  int distance(const QL_Adornment& a) const; // Return the number of places
					     // in which this contains `b'
					     // and a contains `f'.
					     // Return -1 if there is any
					     // place in which this contains `f'
					     // and a contains `b' or if the
					     // two adornments have different
					     // lengths.
protected:
  unsigned _len;
  char _value[MAX_ARITY+1];
  int _any;
};

#endif
