/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef QL_EVAL_H
#define QL_EVAL_H
class QL_Term;
class QL_Bindings;
class QL_Iterator;
class QL_Binding_Node;
class Value;

extern int inside_exists; 
// True if we are in the process of evaluating an 'exists' predicate.

extern void QL_eval(QL_Term*, QL_Bindings*);
extern int QL_eval_no_print(QL_Term*);
extern int QL_eval_exists(QL_Term*);
extern QL_Iterator *create_iterator(QL_Term *);
extern void *
QL_eval_with_aggregate(QL_Term* error_term, QL_Term *term,
		       void *running_value,
		       QL_Binding_Node *bindings_to_use[],
                       int binding_number,
		       void*(*update_value)(QL_Term*, void*, Value**, int));
#endif
