/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


// $Id: ql_iterator.H,v 1.2 1995/02/13 17:50:51 steve Exp $
#ifndef QL_ITERATOR_H
#define QL_ITERATOR_H

#ifndef BASICS_H
#include "basics.H"
#endif

#ifndef QL_TERM_H
#include "ql_term.H"
#endif

#ifndef QL_ARGS_H
#include "ql_args.H"
#endif

#ifndef QL_BUILTIN_IMPL_H
#include "ql_builtin_impl.H"
#endif

class QL_Term;

class QL_Iterator_State;
// The actual interpretation of the state is known only to the first and
// next functions contained in the iterator.  Therefore, QL_Iterator_State *
// resembles void *.


class QL_Iterator
{
public:
  QL_Iterator(QL_Term*, int input_number, int output_number,
	      Builtin_First_Fn, Builtin_Next_Fn next = 0,
	      int unbound_outputs_ok = 0);

  ~QL_Iterator();

  int true_bindings();

  SLOT(QL_Term*,term);       // The term is used for error reporting.

private:
  Builtin_First_Fn _first;
  Builtin_Next_Fn _next;
  int _started;
  QL_Iterator_State *_state;
  int _input_number, _output_number;
  Value **_inputs, **_outputs;
  QL_Binding_Node **_node_outputs;
  void set_in_and_outputs(QL_Term *, int in_count, int out_count);
  void clear_bindings();
  int set_bindings();
};
#endif


